Bug 118401

Summary: fourthTier: FTL should better report its compile-times and it should be able to run in a mode where it doesn't spend time generating OSR exits
Product: WebKit Reporter: Filip Pizlo <fpizlo>
Component: JavaScriptCoreAssignee: Filip Pizlo <fpizlo>
Status: RESOLVED FIXED    
Severity: Normal CC: barraclough, ggaren, mark.lam, mhahnenberg, msaboff, oliver, sam
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: All   
OS: All   
Bug Depends on:    
Bug Blocks: 118400    
Attachments:
Description Flags
the patch sam: review+

Description Filip Pizlo 2013-07-04 12:12:30 PDT
My current suspicion is that most of the time is spent in OSR exit computation.  We know we can do better there, so it would be useful to be able to confirm this hypothesis on a variety of benchmarks.
Comment 1 Filip Pizlo 2013-07-04 12:13:46 PDT
Created attachment 206109 [details]
the patch
Comment 2 Filip Pizlo 2013-07-05 18:10:56 PDT
Landed in http://trac.webkit.org/changeset/152432
Comment 3 Geoffrey Garen 2013-07-08 09:24:16 PDT
> My current suspicion is that most of the time is spent in OSR exit computation.

Did this turn out to be true?
Comment 4 Filip Pizlo 2013-07-08 09:55:38 PDT
(In reply to comment #3)
> > My current suspicion is that most of the time is spent in OSR exit computation.
> 
> Did this turn out to be true?

Currently LLVM compile times reduce by 30% if it doesn't have to deal with OSR exit marshaling.  So, no, it's not "most" of the time, right now.

But if you consider that we're also spending some significant fraction of time setting up pass managers, contexts, modules, execution engines, etc., I suspect that it'll be more than 30% if those other issues are fixed.